Attribute VB_Name = "DRW_ABMASS"
Option Explicit

Sub CATMain(X, Y, A)

'X = Tabelle in X Richtung
'Y = Tabelle in X Richtung
'A = z.b. CatTableTopRight (Aufhngepunkt der Tabelle)

Dim CATIA As Object
Set CATIA = GetObject(, "CATIA.application")

Dim MyDrwDoc As DrawingDocument
Dim MySheets As DrawingSheets
Dim MySheet As DrawingSheets
Dim MyViews As DrawingViews
Dim MyView As DrawingView
Dim MyDimensions  As DrawingDimensions
Dim MyDimension As DrawingDimension
Dim oName
Dim ViewCount As Integer
Dim MyFileName As String
Dim fso
Dim sDatei
Dim MyValue
Dim MyPrec
Dim sZeile As String
Dim MyTempArray

Set MyDrwDoc = CATIA.ActiveDocument
Set MySheets = MyDrwDoc.Sheets
Set MyViews = MySheets.ActiveSheet.Views

Dim oTolType As Long
Dim oTolName As String
Dim oUpTol As String
Dim oLowTol As String
Dim odUpTol As Double
Dim odLowTol As Double
Dim oDispl As Long

'Alte Tabelle lschen
Set selection = MyDrwDoc.selection
selection.Search "(Name:*ABMASSTABELLE* );Alle"
If selection.Count > 0 Then
    selection.Delete
    selection.Clear
End If

'*** Hintergrundansicht aktivieren ********

MyViews.Item("View.2").Activate
MyViews.Item("View.2").Activate

'***********************

    'beginn Tabelle**************
    Set DRWView = MySheets.ActiveSheet.Views.ActiveView
    Dim MyTable As Variant 'DrawingTable
    Set MyTable = DRWView.Tables.Add(X, Y, 1, 3, 6, 27)
    MyTable.Name = "ABMASSTABELLE"
    MyTable.SetCellString 1, 1, "Passmass"
    MyTable.SetCellAlignment 1, 1, CatTableMiddleCenter
    Set oName = MyTable.GetCellObject(1, 1)
    oName.SetFontSize 0, 0, 2.5
    MyTable.SetCellString 1, 2, "Mindestmass"
    MyTable.SetCellAlignment 1, 2, CatTableMiddleCenter
    Set oName = MyTable.GetCellObject(1, 2)
    oName.SetFontSize 0, 0, 2.5
    MyTable.SetCellString 1, 3, "Hchstmass"
    MyTable.SetCellAlignment 1, 3, CatTableMiddleCenter
    Set oName = MyTable.GetCellObject(1, 3)
    oName.SetFontSize 0, 0, 2.5
    
    MyTable.AnchorPoint = A
    '******************************

'Ansichten durchspielen
'Set MyDimensions = MyViews.ActiveView.Dimensions

ViewCount = 1

Do While MyViews.Count > ViewCount - 1

    Set MyDimensions = MyViews.Item(ViewCount).Dimensions
    
Dim Item As Integer
Item = 1

Do While MyDimensions.Count > Item - 1

    '******************************************
    MyFileName = "C:\CATIA\tolerance.kon"
    Set fso = CreateObject("Scripting.FileSystemObject")
    If fso.FileExists(MyFileName) Then
    Set sDatei = fso.OpenTextFile(MyFileName)
    End If
    '******************************************
    
    Set MyDimension = MyDimensions.Item(Item)
    MyValue = MyDimension.GetValue.Value
    MyPrec = MyDimension.GetValue.GetFormatPrecision(1)
    
    'hier runden wenn ntig
    MyValue = MyValueRound(MyValue, MyPrec)
         
    oTolType = 0
    oTolName = ""
    oUpTol = ""
    oLowTol = ""
    odUpTol = 0
    odLowTol = 0
    oDispl = 0

    MyDimension.GetTolerances oTolType, oTolName, oUpTol, oLowTol, odUpTol, odLowTol, oDispl
        
    If oTolType = 2 Then
                                   
        Do While Not (sDatei.AtEndOfStream)
            sZeile = sDatei.ReadLine
            MyTempArray = Split(sZeile, ";")
            
            If oUpTol = MyTempArray(0) Or oLowTol = MyTempArray(0) Then
            
                If CLng(MyValue) > CLng(MyTempArray(1)) And CLng(MyValue) <= CLng(MyTempArray(2)) Then

                    MyTable.AddRow 1
                    MyTable.SetCellString 1, 1, MyValue & " " & oUpTol & oLowTol
                    MyTable.SetCellAlignment 1, 1, CatTableMiddleCenter
                    Set oName = MyTable.GetCellObject(1, 1)
                    oName.SetFontSize 0, 0, 2.5
                    MyTable.SetCellString 1, 2, MyLeerHinzu(MyValue + MyTempArray(3))
                    MyTable.SetCellAlignment 1, 2, CatTableMiddleRight
                    Set oName = MyTable.GetCellObject(1, 2)
                    oName.SetFontSize 0, 0, 2.5
                    MyTable.SetCellString 1, 3, MyLeerHinzu(MyValue + MyTempArray(4))
                    MyTable.SetCellAlignment 1, 3, CatTableMiddleRight
                    Set oName = MyTable.GetCellObject(1, 3)
                    oName.SetFontSize 0, 0, 2.5

                End If
            End If
        Loop
        
    End If
                  
    Item = Item + 1
            
Loop

ViewCount = ViewCount + 1

Loop

'Tabelle formatieren
selection.Search "(Name:*ABMASSTABELLE* );Alle"
selection.VisProperties.SetRealColor 0, 0, 0, 1
selection.VisProperties.SetRealWidth 2, 0
selection.Clear

'Arbeitsansicht aktivieren

MyViews.Item("View.1").Activate
MyViews.Item("View.1").Activate

End Sub
Public Static Function Round( _
    ByVal Value As Variant, _
    Optional ByVal Digits As Integer = 0 _
  ) As Variant
  Dim i As Long
  Dim Pot10(-28 To 28) As Variant

  If i = 0 Then
    For i = LBound(Pot10) To UBound(Pot10)
      Pot10(i) = CDec(10 ^ i)
    Next i
  End If
  
On Error Resume Next
    If Value > 0 Then
    Round = Int(Value * Pot10(Digits) + 0.5) * Pot10(-Digits)
    Else
    Round = -Int(-Value * Pot10(Digits) + 0.5) * Pot10(-Digits)
    End If
    If Err.Number Then Round = Value
On Error GoTo 0
  
End Function
Function MyValueRound(MyValue, MyPrec) As Double
Dim MyTemp
Dim MyLength

On Error Resume Next
MyTemp = Split(MyPrec, ",")
MyLength = Len(MyTemp(1))
MyValueRound = Round(MyValue, MyLength)
End Function
Function MyLeerHinzu(MyValue) As String
Dim MyTempArray

On Error GoTo weiter
    MyTempArray = Split(MyValue, ",")
    Do While Len(MyTempArray(1)) < 3
        MyTempArray(1) = MyTempArray(1) & 0
    Loop
    MyValue = MyTempArray(0) & "," & MyTempArray(1)
    MyLeerHinzu = MyValue & " "
    Exit Function

weiter:
MyLeerHinzu = MyValue & ",000 "
End Function


